//****************************************************************************
//	aisa23w.pas
//
//	aISA-P08
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/05/31
//
//****************************************************************************

unit aisa08w;

interface

uses
	Windows;

{ Errors }

const
	AISA08_SUCCESS							= 0;	 { ُȂ }
	AISA08_ERR_SYSTEM						= 1;	 { GetLastError sĂ }
	AISA08_ERR_NO_DEVICE				= 2;	 { gXbgȂ}
	AISA08_ERR_IN_USE						= 3;	 { w肳ꂽXbg͎gp }
	AISA08_ERR_INVALID_SLOT			= 4;	 { sȃXbgԍw肵 }
	AISA08_ERR_RESOURCE					= 5;	 { \[XG[ }
	AISA08_ERR_INVALID_PORT			= 6;	 { sȃ|[gv }
	AISA08_ERR_INVALID_ARGUMENT = 7;	 { sȈv }

{ Port numbers }

const
	AISA08_PORT_0	= 0;
	AISA08_PORT_1	= 1;
  AISA08_PORT_2	= 2;


{ Miscellaneous }

const
	AISA08_MAX_SLOTS	= 16;	{ Maximum number of slots }

const
	AISA08_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA08_DLL_NAME = 'aisa08.dll';		{ DLL }

function Aisa08wDllOpen: Boolean;			{ DLL [h }
function Aisa08wDllClose: Boolean;		{ DLL A[h }


const
	AISA08_SLOT_AUTO = $ffff;

{ aISA-P08 DLL,Driver̃o[Wԍ擾 }
function Aisa08wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ CӂaISA-P08̎gp錾 }
function Aisa08wCreate(var pwLogSlot: Word): Boolean;
{ CӂaISA-P08̎gpJ }
function Aisa08wClose(wLogSlot: Word): Boolean;


{ Resource infomation structure }

const
		AISA08_MAX_MEM	=	 9;
		AISA08_MAX_IO		= 20;
		AISA08_MAX_IRQ	=	 7;
		AISA08_MAX_DMA	=	 7;

type
		TAISA08RESOURCE = record
				dwNumMemWindows:DWORD;																	{ EBhE gp }
				dwMemBase:			array [1 .. AISA08_MAX_MEM] of DWORD;		{ EChEx[XAhX@gp }
				dwMemLength:		array [1 .. AISA08_MAX_MEM] of DWORD;		{ EChE@gp }
				dwMemAttrib:		array [1 .. AISA08_MAX_MEM] of DWORD;		{ EChE@gp }
				dwNumIOPorts:		DWORD;																	{ I/O|[g }
				dwIOPortBase:		array [1 .. AISA08_MAX_IO] of DWORD;		{ I/O|[gx[XAhX }
				dwIOPortLength: array [1 .. AISA08_MAX_IO] of DWORD;		{ I/O|[g }
				dwNumIRQs:			DWORD;																	{ IRQ@gp }
				dwIRQRegisters: array [1 .. AISA08_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwIRQAttrib:		array [1 .. AISA08_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwNumDMAs:			DWORD;																	{ DMA`l gp }
				dwDMALst:				array [1 .. AISA08_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwDMAAttrib:		array [1 .. AISA08_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwReserved1:		array [1 .. 3] of DWORD;								{ \  }
		end;

PAISA08RESOURCE = ^TAISA08RESOURCE;

{ \[X擾 }
function Aisa08wGetResource(wLogSlot: Word;  pResInfo: PAISA08RESOURCE): Boolean;

{ Cӂ̃|[gփf[^o }
function Aisa08wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;

{ aISA-P08̃G[R[h }
function Aisa08wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa08GetVersion = function(var pdwDllVer: DWORD; var pdwDrvVer: DWORD): BOOL; stdcall;
	TAisa08Create = function(var pwLogSlot: Word): BOOL; stdcall;
	TAisa08Close = function(wLogSlot:	WORD): BOOL; stdcall;
	TAisa08GetResource = function(wLogSlot: WORD; res: PAISA08RESOURCE):	BOOL; stdcall;
	TAisa08OutPort = function(wLogSlot: WORD; dwLogPort: DWORD; bOutValue: BYTE): BOOL; stdcall;
	TAisa08GetLastError = function(wLogSlot: WORD): DWORD; stdcall;

function Aisa08wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

 { DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa08GetVersion: TAisa08GetVersion;
	pAisa08Create: TAisa08Create;
	pAisa08Close: TAisa08Close;
	pAisa08GetResource: TAisa08GetResource;
	pAisa08OutPort: TAisa08OutPort;
	pAisa08GetLastError: TAisa08GetLastError;


//****************************************************************************
// @\			aisa08.dll[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa08wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA08_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa08wGetDllExportFunc = False then
  begin
       Aisa08wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		   Exit;
  end;

	Result := True;
end;

//****************************************************************************
// @\			aisa08.dllA[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa08wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// @\			aISA-P08 DLL,Driver̃o[Wԍ擾
// 			pdwDllVer --- DLLo[Wԍi[
//					pdwDrvVer --- Drivero[Wԍi[
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa08wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa08GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// @\			aISA-P08̔Cӂ̃foCX̎gp錾
// 			pwLogSlot	 --- gpfoCXi[AhX
// ߂l 	True  		 --- 
//		  		False 		 --- s
//****************************************************************************
function Aisa08wCreate(var pwLogSlot: Word): Boolean;
begin
  Result := False;

  if hDLL = 0 then Exit;

	Result := pAisa08Create(pwLogSlot);
end;

//****************************************************************************
// @\			aISA-P08̔Cӂ̃foCX̎gpJ
// 			wLogSlot --- gpfoCX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa08wClose(wLogSlot: Word): Boolean;
begin
  Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa08Close(wLogSlot);
end;

//****************************************************************************
// @\		wfoCX̃\[X擾
// 			wLogSlot --- ׂfoCX
//					pResInfo --- \[Xi[\̂̃AhX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa08wGetResource(wLogSlot: Word;  pResInfo: PAISA08RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa08GetResource(wLogSlot, pResInfo);
end;

//****************************************************************************
// @\			Cӂ̃|[gփf[^o
// 			wLogSlot	--- o͂foCX
//					dwPort		--- o͂|[g
//					bOutValue --- o͂f[^
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa08wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa08OutPort(wLogSlot, dwPort, bOutValue);
end;

//****************************************************************************
// @\			aISA-P08̃G[R[h
// 			wLogSlot --- G[foCX
// ߂l 				 	 --- G[R[h
//****************************************************************************
function Aisa08wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA08_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa08GetLastError(wLogSlot);
end;

//****************************************************************************
// 	  	DLLGNX|[g֐AhX̎擾
// 	  	Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa08wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa08GetVersion ̃AhX擾
	pAisa08GetVersion := GetProcAddress(hDLL, 'Aisa08GetVersion');
	if @pAisa08GetVersion = nil then Exit;

	// Aisa08Create ̃AhX擾
	pAisa08Create := GetProcAddress(hDLL, 'Aisa08Create');
	if @pAisa08Create = nil then Exit;

	// Aisa08Close ̃AhX擾
	pAisa08Close := GetProcAddress(hDLL, 'Aisa08Close');
	if @pAisa08Close = nil then Exit;

	// Aisa08GetResource ̃AhX擾
	pAisa08GetResource := GetProcAddress(hDLL, 'Aisa08GetResource');
	if @pAisa08GetResource = nil then Exit;

	// Aisa08OutPort ̃AhX擾
	pAisa08OutPort := GetProcAddress(hDLL, 'Aisa08OutPort');
	if @pAisa08OutPort = nil then Exit;

	// Aisa08GetLastError ̃AhX擾
	pAisa08GetLastError := GetProcAddress(hDLL, 'Aisa08GetLastError');
	if @pAisa08GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

