/*****************************************************************************
 *	aisa08w.c
 *
 *	aISA-R08
 *
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	Date 1998/05/20
 *
 *****************************************************************************/
#include <windows.h>
#include <tchar.h>
#include "aisa08w.h"	// aISA-R08

//---------- X^eBbN֐ & X^eBbNϐ(萔)	----------------------
static BOOL Aisa08wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[pϐ
static FARPROC pAisa08GetVersion;
static FARPROC pAisa08Create;
static FARPROC pAisa08Close;
static FARPROC pAisa08GetResource;
static FARPROC pAisa08OutPort;
static FARPROC pAisa08GetLastError;

BOOL Aisa08wDllOpen ( void )
/*****************************************************************************
 * @\  aisa08.dll[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL != NULL) {
		return FALSE;
	}
	hDLL = (HMODULE)LoadLibrary(AISA08_DLL_NAME);
	if (hDLL == NULL) {
		return FALSE;
	}
	if (Aisa08wGetDllExportFunc() == FALSE) {
		// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Aisa08wDllClose();
		return FALSE;
	}
	return TRUE;
}

BOOL Aisa08wDllClose ( void )
/*****************************************************************************
 * @\  aisa08.dllA[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	if (FreeLibrary(hDLL) == TRUE) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

BOOL Aisa08wGetVersion ( PDWORD pdwDllVer, PDWORD pdwDrvVer )
/*****************************************************************************
 * @\  aISA-R08DLL,Driver̃o[Wԍ擾
 * 	 pdwDllVer --- DLLo[Wԍi[AhX
 *		 pdwDrvVer --- Drivero[Wԍi[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa08GetVersion)(pdwDllVer, pdwDrvVer);
}

BOOL Aisa08wCreate ( PWORD pwLogSlot )
/*****************************************************************************
 * @\  aISA-R08̔Cӂ̃foCX̎gp錾
 * 	 pwLogSlot	--- gpfoCXi[AhX
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa08Create)(pwLogSlot);
}

BOOL Aisa08wClose ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-R08̔Cӂ̃foCX̎gpJ
 * 	 wLogSlot  --- gpfoCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa08Close)(wLogSlot);
}

BOOL Aisa08wGetResource ( WORD wLogSlot, PAISA08R pResInfo )
/*****************************************************************************
 * @\  wfoCX̃\[X擾
 * 	 wLogSlot --- ׂfoCX
 *		 pResInfo --- \[Xi[\̂̃AhX
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa08GetResource)(wLogSlot, pResInfo);
}

BOOL Aisa08wOutPort ( WORD wLogSlot, DWORD dwPort, BYTE bOutValue )
/*****************************************************************************
 * @\  Cӂ̃|[gփf[^o
 * 	 wLogSlot  --- o͂foCX
 *		 dwPort	   --- o͂|[g
 *		 bOutValue --- o̓f[^
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa08OutPort)(wLogSlot, dwPort, bOutValue);
}

DWORD Aisa08wGetLastError ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-R08̃G[R[h
 * 	 wLogSlot  --- G[foCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return AISA08_ERR_WRAPDLL;
	}
	return (*pAisa08GetLastError)(wLogSlot);
}

static BOOL Aisa08wGetDllExportFunc ( void )
/*---------------------------------------------------------------------------
 * 	 DLLGNX|[g֐AhX̎擾
 * 	 Ȃ
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *---------------------------------------------------------------------------*/
{
	// Aisa08GetVersion ̃AhX擾
	pAisa08GetVersion = GetProcAddress(hDLL, _T("Aisa08GetVersion"));
	if (pAisa08GetVersion == NULL) {
		return FALSE;
	}

	// Aisa08Create ̃AhX擾
	pAisa08Create = GetProcAddress(hDLL, _T("Aisa08Create"));
	if (pAisa08Create == NULL) {
		return FALSE;
	}

	// Aisa08Close ̃AhX擾
	pAisa08Close = GetProcAddress(hDLL, _T("Aisa08Close"));
	if (pAisa08Close == NULL) {
		return FALSE;
	}

	// Aisa08GetResource ̃AhX擾
	pAisa08GetResource = GetProcAddress(hDLL, _T("Aisa08GetResource"));
	if (pAisa08GetResource == NULL) {
		return FALSE;
	}

	// Aisa08OutPort ̃AhX擾
	pAisa08OutPort = GetProcAddress(hDLL, _T("Aisa08OutPort"));
	if (pAisa08OutPort == NULL) {
		return FALSE;
	}

	// Aisa08GetLastError ̃AhX擾
	pAisa08GetLastError = GetProcAddress(hDLL, _T("Aisa08GetLastError"));
	if (pAisa08GetLastError == NULL) {
		return FALSE;
	}
	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
